# VNode factories for HTML elements

```ts
function a(className?: string): VNode<HTMLAnchorElementProps | null>;
function abbr(className?: string): VNode<HTMLElementProps | null>;
function acronym(className?: string): VNode<HTMLElementProps | null>;
function address(className?: string): VNode<HTMLElementProps | null>;
function area(className?: string): VNode<HTMLAreaElementProps | null>;
function article(className?: string): VNode<HTMLElementProps | null>;
function aside(className?: string): VNode<HTMLElementProps | null>;
function audio(className?: string): VNode<HTMLAudioElementProps | null>;
function b(className?: string): VNode<HTMLElementProps | null>;
function base(className?: string): VNode<HTMLBaseElementProps | null>;
function basefont(className?: string): VNode<HTMLBaseFontElementProps | null>;
function bdo(className?: string): VNode<HTMLElementProps | null>;
function big(className?: string): VNode<HTMLElementProps | null>;
function blockquote(className?: string): VNode<HTMLQuoteElementProps | null>;
function body(className?: string): VNode<HTMLBodyElementProps | null>;
function br(className?: string): VNode<HTMLBRElementProps | null>;
function button(className?: string): VNode<HTMLButtonElementProps | null>;
function canvas(className?: string): VNode<HTMLCanvasElementProps | null>;
function caption(className?: string): VNode<HTMLTableCaptionElementProps | null>;
function center(className?: string): VNode<HTMLElementProps | null>;
function cite(className?: string): VNode<HTMLElementProps | null>;
function code(className?: string): VNode<HTMLElementProps | null>;
function col(className?: string): VNode<HTMLTableColElementProps | null>;
function colgroup(className?: string): VNode<HTMLTableColElementProps | null>;
function datalist(className?: string): VNode<HTMLDataListElementProps | null>;
function dd(className?: string): VNode<HTMLElementProps | null>;
function del(className?: string): VNode<HTMLModElementProps | null>;
function dfn(className?: string): VNode<HTMLElementProps | null>;
function dir(className?: string): VNode<HTMLDirectoryElementProps | null>;
function div(className?: string): VNode<HTMLDivElementProps | null>;
function dl(className?: string): VNode<HTMLDListElementProps | null>;
function dt(className?: string): VNode<HTMLElementProps | null>;
function em(className?: string): VNode<HTMLElementProps | null>;
function embed(className?: string): VNode<HTMLEmbedElementProps | null>;
function fieldset(className?: string): VNode<HTMLFieldSetElementProps | null>;
function figcaption(className?: string): VNode<HTMLElementProps | null>;
function figure(className?: string): VNode<HTMLElementProps | null>;
function font(className?: string): VNode<HTMLFontElementProps | null>;
function footer(className?: string): VNode<HTMLElementProps | null>;
function form(className?: string): VNode<HTMLFormElementProps | null>;
function frame(className?: string): VNode<HTMLFrameElementProps | null>;
function frameset(className?: string): VNode<HTMLFrameSetElementProps | null>;
function h1(className?: string): VNode<HTMLHeadingElementProps | null>;
function h2(className?: string): VNode<HTMLHeadingElementProps | null>;
function h3(className?: string): VNode<HTMLHeadingElementProps | null>;
function h4(className?: string): VNode<HTMLHeadingElementProps | null>;
function h5(className?: string): VNode<HTMLHeadingElementProps | null>;
function h6(className?: string): VNode<HTMLHeadingElementProps | null>;
function head(className?: string): VNode<HTMLHeadElementProps | null>;
function header(className?: string): VNode<HTMLElementProps | null>;
function hgroup(className?: string): VNode<HTMLElementProps | null>;
function hr(className?: string): VNode<HTMLHRElementProps | null>;
function html(className?: string): VNode<HTMLHtmlElementProps | null>;
function i(className?: string): VNode<HTMLElementProps | null>;
function iframe(className?: string): VNode<HTMLIFrameElementProps | null>;
function img(className?: string): VNode<HTMLImageElementProps | null>;
function ins(className?: string): VNode<HTMLModElementProps | null>;
function isindex(className?: string): VNode<HTMLUnknownElementProps | null>;
function kbd(className?: string): VNode<HTMLElementProps | null>;
function keygen(className?: string): VNode<HTMLElementProps | null>;
function label(className?: string): VNode<HTMLLabelElementProps | null>;
function legend(className?: string): VNode<HTMLLegendElementProps | null>;
function li(className?: string): VNode<HTMLLIElementProps | null>;
function link(className?: string): VNode<HTMLLinkElementProps | null>;
function listing(className?: string): VNode<HTMLPreElementProps | null>;
function map(className?: string): VNode<HTMLMapElementProps | null>;
function mark(className?: string): VNode<HTMLElementProps | null>;
function menu(className?: string): VNode<HTMLMenuElementProps | null>;
function meta(className?: string): VNode<HTMLMetaElementProps | null>;
function meter(className?: string): VNode<HTMLMeterElementProps | null>;
function nav(className?: string): VNode<HTMLElementProps | null>;
function nextid(className?: string): VNode<HTMLUnknownElementProps | null>;
function nobr(className?: string): VNode<HTMLElementProps | null>;
function noframes(className?: string): VNode<HTMLElementProps | null>;
function noscript(className?: string): VNode<HTMLElementProps | null>;
function object(className?: string): VNode<HTMLObjectElementProps | null>;
function ol(className?: string): VNode<HTMLOListElementProps | null>;
function optgroup(className?: string): VNode<HTMLOptGroupElementProps | null>;
function option(className?: string): VNode<HTMLOptionElementProps | null>;
function p(className?: string): VNode<HTMLParagraphElementProps | null>;
function param(className?: string): VNode<HTMLParamElementProps | null>;
function picture(className?: string): VNode<HTMLPictureElementProps | null>;
function plaintext(className?: string): VNode<HTMLElementProps | null>;
function pre(className?: string): VNode<HTMLPreElementProps | null>;
function progress(className?: string): VNode<HTMLProgressElementProps | null>;
function q(className?: string): VNode<HTMLQuoteElementProps | null>;
function rt(className?: string): VNode<HTMLElementProps | null>;
function ruby(className?: string): VNode<HTMLElementProps | null>;
function s(className?: string): VNode<HTMLElementProps | null>;
function samp(className?: string): VNode<HTMLElementProps | null>;
function script(className?: string): VNode<HTMLScriptElementProps | null>;
function section(className?: string): VNode<HTMLElementProps | null>;
function select(className?: string): VNode<HTMLSelectElementProps | null>;
function small(className?: string): VNode<HTMLElementProps | null>;
function source(className?: string): VNode<HTMLSourceElementProps | null>;
function span(className?: string): VNode<HTMLSpanElementProps | null>;
function strike(className?: string): VNode<HTMLElementProps | null>;
function strong(className?: string): VNode<HTMLElementProps | null>;
function style(className?: string): VNode<HTMLStyleElementProps | null>;
function sub(className?: string): VNode<HTMLElementProps | null>;
function sup(className?: string): VNode<HTMLElementProps | null>;
function table(className?: string): VNode<HTMLTableElementProps | null>;
function tbody(className?: string): VNode<HTMLTableSectionElementProps | null>;
function td(className?: string): VNode<HTMLTableDataCellElementProps | null>;
function template(className?: string): VNode<HTMLTemplateElementProps | null>;
function textarea(className?: string): VNode<HTMLTextAreaElementProps | null>;
function tfoot(className?: string): VNode<HTMLTableSectionElementProps | null>;
function th(className?: string): VNode<HTMLTableHeaderCellElementProps | null>;
function thead(className?: string): VNode<HTMLTableSectionElementProps | null>;
function title(className?: string): VNode<HTMLTitleElementProps | null>;
function tr(className?: string): VNode<HTMLTableRowElementProps | null>;
function track(className?: string): VNode<HTMLTrackElementProps | null>;
function tt(className?: string): VNode<HTMLElementProps | null>;
function u(className?: string): VNode<HTMLElementProps | null>;
function ul(className?: string): VNode<HTMLUListElementProps | null>;
function video(className?: string): VNode<HTMLVideoElementProps | null>;
function wbr(className?: string): VNode<HTMLElementProps | null>;
function x_ms_webview(className?: string): VNode<MSHTMLWebViewElementProps | null>;
function xmp(className?: string): VNode<HTMLPreElementProps | null>;
```

## Input Elements

```ts
function inputButton(className?: string): VNode<HTMLInputElementProps | null>;
function inputCheckbox(className?: string): VNode<HTMLInputElementProps | null>;
function inputColor(className?: string): VNode<HTMLInputElementProps | null>;
function inputDate(className?: string): VNode<HTMLInputElementProps | null>;
function inputDatetime(className?: string): VNode<HTMLInputElementProps | null>;
function inputDatetimeLocal(className?: string): VNode<HTMLInputElementProps | null>;
function inputEmail(className?: string): VNode<HTMLInputElementProps | null>;
function inputFile(className?: string): VNode<HTMLInputElementProps | null>;
function inputHidden(className?: string): VNode<HTMLInputElementProps | null>;
function inputImage(className?: string): VNode<HTMLInputElementProps | null>;
function inputMonth(className?: string): VNode<HTMLInputElementProps | null>;
function inputNumber(className?: string): VNode<HTMLInputElementProps | null>;
function inputPassword(className?: string): VNode<HTMLInputElementProps | null>;
function inputRadio(className?: string): VNode<HTMLInputElementProps | null>;
function inputRange(className?: string): VNode<HTMLInputElementProps | null>;
function inputReset(className?: string): VNode<HTMLInputElementProps | null>;
function inputSearch(className?: string): VNode<HTMLInputElementProps | null>;
function inputSubmit(className?: string): VNode<HTMLInputElementProps | null>;
function inputTel(className?: string): VNode<HTMLInputElementProps | null>;
function inputText(className?: string): VNode<HTMLInputElementProps | null>;
function inputTime(className?: string): VNode<HTMLInputElementProps | null>;
function inputUrl(className?: string): VNode<HTMLInputElementProps | null>;
function inputWeek(className?: string): VNode<HTMLInputElementProps | null>;
```
